/* DATUM.C: Datumok kezelese. */
#include "datum.h"

#define MINDATUM 366
static const long MAXDATUM =
  9999*365l + 9999/4 - 9999/100+9999/400;
static int honap[]= {
  0, 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31 };

const char *NapNev(struct datum *pd) {
  static char *hetnev[]= {"vasarnap", "hetfo", "kedd",
                          "szerda", "csutortok","pentek","szombat" };
  return hetnev[(pd->datumssz)%7l]; }

static int Datume(struct datum *pd) {
  int i;
  honap[2]=28+(!(pd->ev%4)&&pd->ev%100||(!pd->ev%400));
  if(pd->ev<1 || pd->ev>9999 || pd->ho<1 || pd->ho>12 ||
     pd->nap<1 || pd->nap>honap[pd->ho]) {
    pd->evnap=0;
    pd->datumssz=0l;
    return 0;
  } else {
    sprintf(pd->datumlanc, "%04d.%02d.%02d",
            pd->ev, pd->ho, pd->nap);
    pd->evnap=pd->nap;
    for(i=1; i<pd->ho; ++i) pd->evnap+=honap[i];
    pd->datumssz=(pd->ev-1)*365l+pd->evnap+
                 pd->ev/4-pd->ev/100+pd->ev/400;
    return 1; } }

int DatumEHN(int e, int h, int n, struct datum *pd) {
  pd->ev=e;
  pd->ho=h;
  pd->nap=n;
  if(e>=0&&h>=0&&n>=0&&e<10000&&h<100&&n<100)
    sprintf(pd->datumlanc, "%04d.%02d.%02d", e, h, n);
  else *pd->datumlanc=0;
  return Datume(pd); }

int DatumKAR(const char *lanc, struct datum *pd) {
  pd->ho=pd->nap=0;
  strncpy(pd->datumlanc, lanc, 10);
  pd->datumlanc[10] = 0;
  pd->ev=atoi(lanc);
  while(isdigit(*lanc))++lanc;
  if(*lanc!=0) {
    ++lanc;
    pd->ho=atoi(lanc);
    while(isdigit(*lanc))++lanc;
    if(*lanc) {
      ++lanc;
      pd->nap=atoi(lanc); } }
  return Datume(pd); }

long DatumKul(struct datum *pd1, struct datum *pd2) {
  if(pd1->datumssz>pd2->datumssz)
    return pd1->datumssz-pd2->datumssz;
  else return pd2->datumssz-pd1->datumssz; }

struct datum DatumMegEgy(struct datum *pd) {
  int e=pd->ev, h=pd->ho, n=pd->nap;
  struct datum d;
  honap[2]=28+(e%4==0 && e%100 || e%400==0);
  if(++n>honap[h]) {
    n=1;
    ++h;
    if(h>12) {
      h=1;
      ++e; } }
  if(!DatumEHN(e, h, n, &d)) d=*pd;
  return d; }

struct datum DatumMegint(struct datum *pd, int np) {
  int e=pd->ev, h=pd->ho, n=pd->nap;
  long dpd = pd->datumssz + np + 365;
  /* A tiszta jo konstans 365.24223 lenne kezi
     szamitas szerint!!!! */
  static double oszto=365.24225;
  struct datum d=*pd;
  if(np <= 0) return d;
  if(dpd > MAXDATUM) {
    e=9999;
    h=12;
    n=31;
  } else {
    e= (int)dpd/oszto;
    n=dpd-e*365l-e/4+e/100-e/400;
    honap[2]=28+(e%4==0 && e%100 || e%400==0);
    for(h=1; n > honap[h]; ++h)n-=honap[h]; }
  if(!DatumEHN(e, h, n, &d)) d=*pd;
  return d; }

