/* PELDA18Y.C: Egesz szamok atlaga, minimuma, maximuma es
   rendezese. A modosult programsorokat megcsillagoztuk:
                                               ********* */
#include <stdio.h>
#include <stdlib.h> /* Az atoi miatt! */
#include <limits.h> /* INT_MIN es INT_MAX vegett! */
#define MAX 100 /* A tomb max. elemszama. */
#define INP 20  /* Az input puffer merete. */
int getline(char s[],int lim) {
  int c,i;
  for(i=0; i<lim&&(c=getchar())!=EOF&&c!='\n'; ++i)s[i]=c;
  s[i]='\0';
  while(c!=EOF && c!='\n') c=getchar();
  return(i); }
/* A decimalis szamjegyek szama maximalisan: */
#define HSZ sizeof(int)/sizeof(short)*5
int egesze(const char s[], int *ertek) { /* ********* */
  int i = 0, kezd;
  /* A karakterlanc eleji feher karakterek atlepese: */
  while(s[i]==' ' || s[i]=='\n' || s[i]=='\t') ++i;
  /* Az elojel atlepese: */
  if(s[i]=='+' || s[i]=='-') ++i;
  kezd=i; /* A szamjegyek itt kezdodnek. */
  /* Elore a kovetkezo nem numerikus karakterre: */
  while(s[i]>='0' && s[i]<='9' && i-kezd<HSZ) ++i;
  /* Dontes: */
  if(kezd==i || s[i]!='\n' && s[i]!='\t' &&
    s[i]!=' ' && s[i]!=0) return 0;
  else {
    *ertek=atoi(s); /* ********* */
    return 1; } }
void rendez(int a[],int n) {
  int i, j, m, cs;
  for(i=0; i<n-1; ++i) {
    for(j=i+1, m=i; j<n; ++j) if(a[j]<a[m]) m=j;
    if(i!=m) {
      cs=a[i];
      a[i]=a[m];
      a[m]=cs; } } }
void main(void) {
  int n=0; /* A rendezendo elemek szama. */
  char sor[INP+1]; /* Az input puffer. */
  int a[MAX]; /* A egeszeket tarolo tomb. */
  int min, max; /* Minimum, maximum. */
  double osszeg=0.; /* Az osszeg */
  int i;
  while(n<1||n>MAX) {
    printf("\nHany egesz szamot rendezunk(1-%d)? ",MAX);
    getline(sor,INP);
    egesze(sor, &n); } /* ********* */
  printf("\n\n\n\n\nKerem a rendezendo szamokat %d es +%d"
         " kozott!\n", INT_MIN, INT_MAX);
  for(i=0; i<n; ++i) {
    printf("%3d: ", i+1); /* ********* */
    if(!getline(sor,INP)||!egesze(sor,&a[i])) --i; }
  min=max=a[0];
  for(i=0; i<n; osszeg+=a[i],++i)
    if(a[i]<min) min=a[i];
    else if(a[i]>max) max=a[i];
  printf("\nA szamsorozat\tminimuma:%14d.\n"
         "\t\tmaximuma:%14d.\n"
         "\t\tatlaga: %17.2f\n",
         min, max, osszeg/n);
  printf("\nA rendezett szamok:\n");
  rendez(a, n);
  for(i=0; i<n; i++) {
    printf("%13d",a[i]);
    if(!((i+1)%6)) putchar('\n'); }
  putchar('\n'); }

