/* PELDA28.C: A ket, egymastol legtavolabbi pont
              megkeresese. */
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <math.h>
#define INP 28 /* Az input puffer merete. */
#define N 128  /* Pontok maximalis szama. */
struct Pont {  /* A Pont struktura. */
  double x, y; };
int getline(char s[],int n) {
  int c,i;
  for(i=0; i<n&&(c=getchar())!=EOF&&c!='\n'; ++i) s[i]=c;
  s[i]='\0';
  while(c!=EOF&&c!='\n') c=getchar();
  return(i); }
int lebege(char s[]) {
  int i=0, kezd;
  /* Feher karakterek atlepese a lanc elejen: */
  while(isspace(s[i])) ++i;
  /* A mantissza elojele: */
  if(s[i]=='+'||s[i]=='-') ++i;
  kezd=i; /* A szamjegyek itt kezdodnek. */
  /* A mantissza egesz resze: */
  while(isdigit(s[i])) ++i;
  /* A mantissza tort resze: */
  if(s[i]=='.') ++i;
  while(isdigit(s[i])) ++i;
  /* Nincs szamjegy, vagy csak egy . van: */
  if(i==kezd||kezd+1==i&&s[kezd]=='.') return 0;
  /* Kitevo resz: */
  if(toupper(s[i])=='E') {
    ++i;
    if(s[i]=='+'||s[i]=='-')++i;
    /* Egy szamjegynek lennie kell a kitevoben! */
    if(!isdigit(s[i])) return 0;
    while(isdigit(s[i])) ++i; }
  /* Vege: */
  if(isspace(s[i])||!s[i]) return 1;
  else return 0; }
int main(void) {
  char sor[INP+1];     /* Input puffer. */
  struct Pont p[N];    /* Strukturatomb. */
  int n=0;             /* Pontok szama. */
  double max=-1., d;   /* Pillanatnyi maximum es */
  int i, j, tavi, tavj;/*segedvaltozok. */
  printf("A ket egymestol legtavolabbi pont a sikban.\n"
         "Adja meg a pontok koordinataparjait rendre!\n"
         "Vege: ures sor az X koordinata megadasanal.\n\n");
  for(n=0; n<N; ++n) {
    printf("A(z) %d pont koordinatai:\n",n+1);
    if(printf("X: "),getline(sor,INP)<=0)break;
    if(lebege(sor)) p[n].x=atof(sor);
    else {
      --n;
      continue; }
    while(printf("Y: "), getline(sor,INP),
          !lebege(sor));
    p[n].y=atof(sor);   }
  if(n<2) {
    printf("Legalabb ket pontot meg kene adni!\n");
    return(1);   }
  for(i=0; i<n-1; ++i)
    for(j=i+1; j<n; ++j)
      if((d=sqrt((p[j].x-p[i].x)*(p[j].x-p[i].x)+
                 (p[j].y-p[i].y)*(p[j].y-p[i].y))) > max) {
        max=d;
        tavi=i;
        tavj=j; }
  printf(	"A maximalis tavolsagu ket pont:\n"
          "P[%d]: (%10.1f, %10.1f) es\n"
          "P[%d]: (%10.1f, %10.1f),\n"
          "s a tavolsag: %15.2f\n",
          tavi+1, p[tavi].x, p[tavi].y,
          tavj+1, p[tavj].x, p[tavj].y, max);
  return(0); }

