/* PELDA28X.C: A ket, egymastol legtavolabbi pont keresese,
majd a pontok origotol mert tavolsaguk csokkeno sorrendjeben
rendezett listajanak lapozhato megjelenitese. */
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <math.h>
#define INP 28 /* Az input puffer merete. */
#define N 128 /* Pontok maximalis szama. */
#define LAPSOR 20 /* Egy lapra kiirhato sorok szama. */
struct Pont { /* A Pont struktura. */
  double x, y, tav;
};/* tav tag=origotol mert tavolsag. */
int getline(char *s, int n) { /* Sor beolvasasa s-be. */
  int c; /* A hosszat adja vissza. */
  char *t=s; /* Indexeles helyett a t mutatoval
haladunk az s karaktertombon. A t mindig a kovetkezo
szabad helyre mutat a tombben, melynek tulirasat az n
elfogyasa akadalyozza meg. */
  while(n-->0&&(c=getchar())!=EOF&&c!='\n') *t++=c;
  *t='\0';
  while(c!=EOF&&c!='\n') c=getchar();
  /* A karakterlacot zaro '\0' cimebol a tomb kezdocimet
  kivonva, eppen a karakterlanc hosszat kapjuk. */
  return(t-s); }
int lebege(char *s) { /* Atirva mutatosra! */
  char *i=s, *kezd;
  /* Feher karakterek atlepese a lanc elejen: */
  while(isspace(*i)) ++i;
  /* A mantissza elojele: */
  if(*i=='+'||*i=='-') ++i;
  kezd=i; /* A szamjegyek itt kezdodnek. */
  /* A mantissza egesz resze: */
  while(isdigit(*i)) ++i;
  /* A mantissza tort resze: */
  if(*i=='.') ++i;
  while(isdigit(*i)) ++i;
  /* Nincs szamjegy, vagy csak egy . van: */
  if(i==kezd||kezd+1==i&&*kezd=='.') return 0;
  /* Kitevo resz: */
  if(toupper(*i)=='E') {
    ++i;
    if(*i=='+'||*i=='-')++i;
    /* Egy szamjegynek lennie kell a kitevoben! */
    if(!isdigit(*i)) return 0;
    while(isdigit(*i)) ++i; }
  /* Vege: */
  if(isspace(*i)||!*i) return 1;
  else return 0; }
int main(void) {
  char sor[INP+1]; /* Input puffer. */
  struct Pont p[N], /* Strukturatomb. */
      cs; /* Rendezesnel a cserehez. */
  int n=0; /* Pontok szama. */
  double max=-1., d; /* Pillanatnyi maximum es */
  int i, j, tavi, tavj; /* segedvaltozok. */
  printf("A ket egymastol legtavolabbi pont a sikban, "
         "majd a\npontok listaja origotol mert tavolsaguk "
         "sorrendjeben.\n\n"
         "Adja meg a pontok koordinataparjait rendre!\n"
         "Vege: Ures sor az X koordinata megadasanal.\n\n");
  for(n=0; n<N; ++n) {
    printf("A(z) %d pont koordinatai:\n",n+1);
    if(printf("X: "), getline(sor, INP)<=0)break;
    if(lebege(sor)) p[n].x=atof(sor);
    else {
      --n;
      continue; }
    while(printf("Y: "), getline(sor,INP),
          !lebege(sor));
    p[n].y=atof(sor); /* A tavolsag! */
    p[n].tav=sqrt(p[n].x*p[n].x + p[n].y*p[n].y); }
  if(n<2) {
    printf("Legalabb ket pontot meg kene adni!\n");
    return(1); }
  /* A maximalis tavolsagu ket pont megkeresese: */
  for(i=0; i<n-1; ++i)
    for(j=i+1; j<n; ++j)
      if((d=sqrt((p[j].x-p[i].x)*(p[j].x-p[i].x)+
                 (p[j].y-p[i].y)*(p[j].y-p[i].y))) > max) {
        max=d;
        tavi=i;
        tavj=j; }
  printf("A maximalis tavolsagu ket pont:\n"
         "P[%d]: (%10.1f, %10.1f) es\n"
         "P[%d]: (%10.1f, %10.1f),\n"
         "s a tavolsag: %15.2f\n",
         tavi+1, p[tavi].x, p[tavi].y,
         tavj+1, p[tavj].x, p[tavj].y, max);
  /* Rendezes az origotol mert tavolsag szerint
  csokkenoleg: */
  for(i=0; i<n-1; ++i) {
    for(j=i+1, tavi=i; j<n; ++j) if(p[j].tav>p[tavi].tav)
        tavi=j;
    if(i!=tavi) {
      cs=p[i];
      p[i]=p[tavi];
      p[tavi]=cs; } }
  /* Listazas: */
  printf("\nA listazas inditasahoz usson Enter-t! ");
  while(getchar()!='\n');
  for(i=0; i<n; ++i) {
    if(i%LAPSOR==0) { /* Lapvaltas? */
      if(i) { /* Varakozas a lapvegen. */
        printf("A tovabblistazashoz usson Enter-t! ");
        while(getchar()!='\n'); }
      /* Fejlec. */
      printf("\n\n%10s%10s%10s\n", "X", "Y",
             "Tavolsag");
      printf("------------------------------\n"); }
    /* Sorok: */
    printf("%10.1f%10.1f%10.2f\n", p[i].x, p[i].y,
           p[i].tav); }
  return(0); }

