/* PELDA31.C: Elso parameter fajl masolasa a masodikba. */
#include <stdio.h>
#include <string.h> /* strerror miatt! */
#include <errno.h>  /* Az errno vegett! */
#define KENT 10   /* Hanyankent jelenjen meg a szamlalo.*/
#define SZELES 10 /* Mezoszelesseg a szamlo kozlesehez. */
int main(int argc, char *argv[]) {
  FILE *be, *ki;  /* A be es kimeneti fajlok. */
  long szlo=0l; /* A szamlalo. */
  int c;      /* A kov. karakter es segedvaltozo. */
  printf("Az elso parameter fajl masolasa a masodikba:\n");
  if(argc<3) {
    fprintf(stderr, "Programinditas:\n"
            "PELDA30 forrasfajl celfajl\n");
    return 1; }
  if(!(be=fopen(argv[1],"rb"))) {
    perror(argv[1]);
    return 1; }
  if(!(ki=fopen(argv[2],"wb"))) {
    perror(argv[2]);
    fclose(be);
    return 1; }
  printf("%s --> %s:\n%*ld", argv[1], argv[2], SZELES, szlo);
  while((c=fgetc(be))!=EOF) {
    /* Olvasas fajlvegig, vagy hibaig. */
    if(c==fputc(c,ki)) {  /* Kiiras rendben. */
      if(!(++szlo%KENT)) {
        for(c=0; c<SZELES; ++c) fputc('\b', stdout);
        printf("%*ld", SZELES, szlo); }
    } else {      /* Kiirasnal hiba van. */
      perror(argv[2]);
      clearerr(ki);
      if(!fclose(ki))   /* A felkesz fajl torlese. */
        remove(argv[2]);
      else perror(argv[2]);
      fclose(be);
      return 1; } }
  /* Az olvasas EOF ertekkel fejezodott be. */
  c=errno;          /* Hibakod mentese. */
  fclose(ki);
  /* A vegso meret kiirasa: */
  for(c=0; c<SZELES; ++c) fputc('\b', stdout);
  printf("%*ld\n", SZELES, szlo);
  if(ferror(be)) {      /* Hiba volt. */
    fprintf(stderr, "%s: %s\n", argv[1], strerror(c));
    clearerr(be);
    fclose(be);
    remove(argv[2]);
    return 1; }
  fclose(be);         /* Minden rendben ment. */
  return 0; }

